(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = global || self, global.docuteDemoCode = factory());
}(this, function () { 'use strict';

  function stripDemoBlock(text) {
    return text.replace(/(:{3})demo\s*([\s\S]*)\1/, '$2');
  }
  function parseComponent(text) {
    var component = stripDemoBlock(text).replace(/(`{3})(html|vue)([\s\S]*)\s*\1/, '$3');
    var JS_RE = /<(script)>([\s\S]*)<\/\1>/;
    var MODULE_JS_RE = /<(script)>[\s\S]*export\s*default\s*{\s*([\s\S]*)}\s*<\/\1>/;
    var _a = (component.match(JS_RE) || [])[0],
        matchedScript = _a === void 0 ? '' : _a;
    var template = component.replace(JS_RE, '') // Replace all style tag to docute built-in component `<v-style>`
    .replace(/<(\/?)style>/g, '<$1v-style>');
    var options = matchedScript.replace(MODULE_JS_RE, '$2');
    return {
      template: template,
      options: options
    };
  }
  function registerComponent(_a, id) {
    var template = _a.template,
        options = _a.options;
    if (!Vue) return;
    var resolveComponent = new Function("return {template: `<section>" + template + "</section>`," + options + "}");
    Vue.component("Demo" + id, resolveComponent());
  }

  function parser (options) {
    return function (text) {
      var startTag = ':::demo';
      var startTagLen = startTag.length;
      var endTag = ':::';
      var endTagLen = endTag.length;
      var id = 0;
      var start = 0;
      var outputString = text;
      var demoStart = text.indexOf(startTag);
      var demoEnd = text.indexOf(endTag, demoStart + startTagLen) + endTagLen;

      while (demoStart !== -1 && demoEnd !== -1) {
        var demo = text.slice(demoStart, demoEnd);
        var parsed = parseComponent(demo);
        registerComponent(parsed, id);
        outputString = outputString.replace(demo, "<Demo" + id + " " + (options.showBorder ? 'class="pre-wrapper" style="padding: 20px; background: unset"' : '') + "/>\n\n" + stripDemoBlock(demo));
        id++;
        start = demoEnd;
        demoStart = text.indexOf(startTag, start);
        demoEnd = text.indexOf(endTag, demoStart + startTagLen) + endTagLen;
      }

      return outputString;
    };
  }

  function docuteDemoCode(options) {
    if (options === void 0) {
      options = {
        showBorder: true
      };
    }

    return {
      name: 'docute-plugin-demo-code',
      extend: function extend(api) {
        return api.processMarkdown(parser(options));
      }
    };
  }

  return docuteDemoCode;

}));
